/* 
    mmfilter - MIME multipart file attach filter for mnews

	Copyright (C) 1998 Masamichi Takatsu  All rights reserved.

  mmfilter ϡmnews MIMEˤեźդ¸ե륿Ǥ


  1. ܥե򥳥ѥ뤷ѥ̤ä֤ޤ
    : % gcc mmfilter.c -o mmfilter
        % cp mmfilter /usr/local/bind

  2. mnews  .mnews_setup˰ʲ4Ԥɲäޤ

send_filter:    mmfilter
post_filter:    mmfilter
mail_field:     X-mime-attach:
news_field:     X-mime-attach:

    mail_field:  news_field ˴¾ΥإåäƤϡ'\n'
    Ƕڤä 'X-mime-attach:'ɲäƤ

ˡ:
  3. ǥǥƥȤԽȤ X-mime-attach: إåɲä
     ƤޤΤǡեźդȤϤ˥ե̾
     X-mime-attach إåʣԽ񤱤СʣΥեź
     դ뤳ȤǤޤ

  4. Խλȡα̤ˤϡեźպѤߤΥޥ
     ѡȤʤΤɽޤźդƤ뤫ɤǧξ塢
     ԤäƲ

                                            ƻ taka2@doga@co.jp
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <sys/stat.h>
#ifndef __WIN32__
	#include <unistd.h>
#else
	#include <io.h>
	#include <dos.h>
	#define strncasecmp strnicmp
	#define strcasecmp stricmp
#endif

#define FALSE 0
#define TRUE 1

#define BUFFSIZE 65536
#define STRSIZE 256
#define MAX_ATTACH 64
#define F_NAME_LEN 256
#define LINE 57					/* ԤΥ󥳡ɥХȿ(3ܿ)*/
#define LARGEBUFF 65536
#define LARGEUNIT (LARGEBUFF/LINE)

#define MULTIPART_SEPARATOR "-=-mnews-multipart-=-"
#define HEADER_X_MIME_ATTACH	"X-mime-attach:"
#define HEADER_MIME_VERSION	"Mime-Version:"
#define HEADER_CONTENT_TYPE	"Content-Type:"
#define HEADER_CONTENT_TRANSFER_ENCODING	"Content-Transfer-Encoding:"

static FILE *infp = NULL;
static char header[BUFFSIZE];
static char *pheader = header;
static char MimeVersion[BUFFSIZE];
static char ContentType[BUFFSIZE];
static char ContentTransferEncoding[BUFFSIZE];
static char AttachFile[MAX_ATTACH][F_NAME_LEN];
static int nAttachFile = 0;
static int error = FALSE;

typedef struct {
	char *ext, *type;
} MimeTypeInfo;

static MimeTypeInfo mimetypeinfo[] = {
	{"hqx",		"application/mac-binhex40"},
	{"cpt",		"application/mac-compactpro"},
	{"doc",		"application/msword"},
	{"oda",		"application/oda"},
	{"pdf",		"application/pdf"},
	{"ai",		"application/postscript"},
	{"eps",		"application/postscript"},
	{"ps",		"application/postscript"},
	{"ppt",		"application/powerpoint"},
	{"rtf",		"application/rtf"},
	{"bcpio",	"application/x-bcpio"},
	{"vcd",		"application/x-cdlink"},
	{"Z",		"application/x-compress"},
	{"cpio",	"application/x-cpio"},
	{"csh",		"application/x-csh"},
	{"dcr",		"application/x-director"},
	{"dir",		"application/x-director"},
	{"dxr",		"application/x-director"},
	{"dvi",		"application/x-dvi"},
	{"gtar",	"application/x-gtar"},
	{"gz",		"application/x-gzip"},
	{"hdf",		"application/x-hdf"},
	{"skp",		"application/x-koan"},
	{"skd",		"application/x-koan"},
	{"skt",		"application/x-koan"},
	{"skm",		"application/x-koan"},
	{"latex",	"application/x-latex"},
	{"mif",		"application/x-mif"},
	{"nc",		"application/x-netcdf"},
	{"cdf",		"application/x-netcdf"},
	{"sh",		"application/x-sh"},
	{"shar",	"application/x-shar"},
	{"sit",		"application/x-stuffit"},
	{"sv4cpio",	"application/x-sv4cpio"},
	{"sv4crc",	"application/x-sv4crc"},
	{"tar",		"application/x-tar"},
	{"tcl",		"application/x-tcl"},
	{"tex",		"application/x-tex"},
	{"texinfo",	"application/x-texinfo"},
	{"texi",	"application/x-texinfo"},
	{"t",		"application/x-troff"},
	{"tr",		"application/x-troff"},
	{"roff",	"application/x-troff"},
	{"man",		"application/x-troff-man"},
	{"me",		"application/x-troff-me"},
	{"ms",		"application/x-troff-ms"},
	{"ustar",	"application/x-ustar"},
	{"src",		"application/x-wais-source"},
	{"zip",		"application/zip"},
	{"au",		"audio/basic"},
	{"snd",		"audio/basic"},
	{"mpga",	"audio/mpeg"},
	{"mp2",		"audio/mpeg"},
	{"aif",		"audio/x-aiff"},
	{"aiff",	"audio/x-aiff"},
	{"aifc",	"audio/x-aiff"},
	{"ram",		"audio/x-pn-realaudio"},
	{"rpm",		"audio/x-pn-realaudio-plugin"},
	{"ra",		"audio/x-realaudio"},
	{"wav",		"audio/x-wav"},
	{"pdb",		"chemical/x-pdb"},
	{"xyz",		"chemical/x-pdb"},
	{"gif",		"image/gif"},
	{"ief",		"image/ief"},
	{"jpeg",	"image/jpeg"},
	{"jpg",		"image/jpeg"},
	{"jpe",		"image/jpeg"},
	{"png",		"image/png"},
	{"tiff",	"image/tiff"},
	{"tif",		"image/tiff"},
	{"ras",		"image/x-cmu-raster"},
	{"pnm",		"image/x-portable-anymap"},
	{"pbm",		"image/x-portable-bitmap"},
	{"pgm",		"image/x-portable-graymap"},
	{"ppm",		"image/x-portable-pixmap"},
	{"rgb",		"image/x-rgb"},
	{"xbm",		"image/x-xbitmap"},
	{"xpm",		"image/x-xpixmap"},
	{"xwd",		"image/x-xwindowdump"},
	{"html",	"text/html"},
	{"htm",		"text/html"},
	{"txt",		"text/plain"},
	{"rtx",		"text/richtext"},
	{"tsv",		"text/tab-separated-values"},
	{"etx",		"text/x-setext"},
	{"sgml",	"text/x-sgml"},
	{"sgm",		"text/x-sgml"},
	{"mpeg",	"video/mpeg"},
	{"mpg",		"video/mpeg"},
	{"mpe",		"video/mpeg"},
	{"qt",		"video/quicktime"},
	{"mov",		"video/quicktime"},
	{"avi",		"video/x-msvideo"},
	{"movie",	"video/x-sgi-movie"},
	{"ice",		"x-conference/x-cooltalk"},
	{"wrl",		"x-world/x-vrml"},
	{"vrml",	"x-world/x-vrml"},

	{"lzh",		"application/x-lha"},
};

static void StripComment(char *dst, char *src)
{
	int incomment = 0;
	for (; *src; src++) {
		if (*src == '(') {
			incomment++;
		} else if (*src == ')') {
			incomment--;
		} else if (incomment <= 0 && *src != ' ' && *src != '\t' && *src != '\r' && *src != '\n' ) {
			*dst++ = *src;
		}
	}
	*dst = '\0';
}

static void ParseAttach(char *line)
{
	char buf[BUFFSIZE];
	StripComment(buf, line);
	if (buf[0] && nAttachFile < MAX_ATTACH-1) {
		strcpy(AttachFile[nAttachFile++], buf);
	}
}

static int ParseHeader(char *line)
{
	if (strncasecmp(line, HEADER_X_MIME_ATTACH, sizeof(HEADER_X_MIME_ATTACH)-1) == 0) {
		ParseAttach(line+14);
		return FALSE;
	} else if (strncasecmp(line, HEADER_MIME_VERSION, sizeof(HEADER_MIME_VERSION)-1) == 0) {
		strcat(MimeVersion, line);
		return FALSE;
	} else if (strncasecmp(line, HEADER_CONTENT_TYPE, sizeof(HEADER_CONTENT_TYPE)-1) == 0) {
		strcat(ContentType, line);
		return FALSE;
	} else if (strncasecmp(line, HEADER_CONTENT_TRANSFER_ENCODING, sizeof(HEADER_CONTENT_TRANSFER_ENCODING)-1) == 0) {
		strcat(ContentTransferEncoding, line);
		return FALSE;
	}
	return TRUE;
}

static void ScanHeader(void)
{
	char line[BUFFSIZE], str[BUFFSIZE];
	line[0] = '\0';
	while (fgets(str, BUFFSIZE, infp)) {
		if (str[0] == '\n' || str[0] == '\0') {
			break;
		} else if (str[0] == ' ' || str[0] == '\t') {
			strcat(line, str);
		} else {
			if (ParseHeader(line)) {
				strcpy(pheader, line);
				pheader += strlen(pheader);
			}
			strcpy(line, str);
		}
	}
	if (line[0]) {
		if (ParseHeader(line)) {
			strcpy(pheader, line);
			pheader += strlen(pheader);
		}
	}
}

void GetType(char *filename, char *filetype, char *basename)
{
	int i;
	char *p, *q;
	char *ext;

	strcpy(filetype, "application/octet-stream");
	if ((p = strrchr(filename, '/')) != NULL) {
		p++;
	} else {
		p = filename;
	}
#ifndef __WIN32__
	q = p;
#else
	if ((q = strrchr(p, '\\')) != NULL) {
		q++;
	} else {
		q = p;
	}
	if (q[0] && q[1] == ':') {
		q += 2;
	}
#endif
	strcpy(basename, q);
	if ((p = strrchr(q, '.')) == NULL) {
		return;
	}
	ext = p+1;
	for (i = 0; i < (sizeof(mimetypeinfo)/sizeof(mimetypeinfo[0])); i++) {
		if (strcasecmp(ext, mimetypeinfo[i].ext) == 0) {
			strcpy(filetype, mimetypeinfo[i].type);
			return;
		}
	}
	return;
}

void B64encode(char *dst, char *src, int len)
{
    static char mimechar[] =
        "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
    int code1, code2, code3;
    for (; len > 0; len -= 3) {
        code1 = *((unsigned char *)src++);
        code2 = *((unsigned char *)src++);
        code3 = *((unsigned char *)src++);
        *dst++ = mimechar[code1 >> 2];
        *dst++ = mimechar[((code1 & 0x03) << 4) | ((code2 & 0xf0) >> 4)];
        *dst++ = mimechar[((code2 & 0x0f) << 2) | ((code3 & 0xc0) >> 6)];
        *dst++ = mimechar[code3 & 0x3f];
    }
    if (len == -2) {
        dst[-2] = dst[-1] = '=';
    } else if (len == -1) {
        dst[-1] = '=';
    }
    *dst = '\0';
}

void MMEncode(FILE *rfp, FILE *wfp)
{
	int i, l;
	char *inbuf, *outbuf, *inp, *outp;
	inbuf = malloc(LARGEUNIT * LINE);
	outbuf = malloc(((LINE/3*4)+1) * LARGEUNIT+2);

	while ((l = fread(inbuf, 1, LARGEUNIT*LINE, rfp)) == LARGEUNIT*LINE) {
		inp = inbuf;
		outp = outbuf;
		for (i = 0; i < LARGEUNIT; i++) {
			B64encode(outp, inp, LINE);
			inp += LINE;
			outp += LINE/3*4;
			*outp++ = '\n';
		}
		*outp = '\0';
		fwrite(outbuf, 1, outp-outbuf, wfp);
	}
	inp = inbuf;
	outp = outbuf;
	while (l > LINE) {
		B64encode(outp, inp, LINE);
		inp += LINE;
		outp += LINE/3*4;
		*outp++ = '\n';
		l -= LINE;
	}
	B64encode(outp, inp, l);
	outp += strlen(outp);
	*outp++ = '\n';
	fwrite(outbuf, 1, outp-outbuf, wfp);
	free(inbuf);
	free(outbuf);
}

void SendBase64(char *filename, FILE *wfp)
{
	FILE *rfp;
	char basename[STRSIZE];
	char filetype[STRSIZE];
	struct	stat	statbuf;

	if ((rfp = fopen(filename, "rb")) == NULL) {
		return;
	}
	stat( filename, &statbuf );
	fprintf(wfp, "--%s\n", MULTIPART_SEPARATOR);
	GetType(filename, filetype, basename);
	fprintf(wfp, "Content-Type: %s; name=\"%s\"\n", filetype, basename);
	fprintf(wfp, "Content-Transfer-Encoding: base64\n");
	fprintf(wfp, "Content-Description: %s\n", basename);
	fprintf(wfp, "Content-Disposition: attachment; filename=\"%s\"\n", basename);
	fprintf(wfp, "\n");
	MMEncode(rfp, wfp); /*, basename, statbuf.st_size);*/
	fprintf(wfp, "\n");
}

void OutputMail(FILE *fp)
{
	int i;
	char str[BUFFSIZE];
	if (nAttachFile) {
		fputs(header, fp);
		fprintf(fp, "MIME-Version: 1.0\n");
		fprintf(fp, "Content-Type: multipart/mixed; boundary=\"%s\"\n",
				MULTIPART_SEPARATOR);
		fprintf(fp, "\n\n");
		fprintf(fp, "--%s\n", MULTIPART_SEPARATOR);
		if (ContentType[0]) {
			fputs(ContentType, fp);
		} else {
			fputs("Content-Type: text/plain; charset=\"ISO-2022-JP\"\n", fp);
		}
		if (ContentTransferEncoding[0]) {
			fputs(ContentTransferEncoding, fp);
		} else {
			fputs("Content-Transfer-Encoding: 7bit\n", fp);
		}
		fputs("\n", fp);
		while (fgets(str, BUFFSIZE, infp)) {
			fputs(str, fp);
		}
		for (i = 0; i < nAttachFile; i++) {
			if (access(AttachFile[i], 0)) {
				fprintf(fp, "Error!! cannot open %s, not attached.\n", 
					AttachFile[i]);
			}
		}
		for (i = 0; i < nAttachFile; i++) {
			SendBase64(AttachFile[i], fp);
		}
		fprintf(fp, "--%s--\n", MULTIPART_SEPARATOR);
	} else {
		fputs(header, fp);
		if (MimeVersion[0]) fputs(MimeVersion, fp);
		if (ContentType[0]) fputs(ContentType, fp);
		if (ContentTransferEncoding[0]) fputs(ContentTransferEncoding, fp);
		fputs("\n", fp);
		while (fgets(str, BUFFSIZE, infp)) {
			fputs(str, fp);
		}
	}
}

int main(int argc, char *argv[])
{
	infp = stdin;
	if (argc >= 2) {
		FILE *fp;
		if ((fp = fopen(argv[1], "r")) == NULL) {
			printf("read '%s' failed.\n", argv[1]);
		}
		infp = fp;
	}
	ScanHeader();
	if (error) {
		sleep(2);
	}
	OutputMail(stdout);
	return 0;
}
